﻿@page "/teamSeasons/teamPlayers/{Id:int}"

@using Models.TeamData
@using Business.Repository.IRepository
@using Dialog 
@inject ITeamPlayerRepository TeamPlayerRepository
@inject IJSRuntime JsRuntime
@inject Blazored.LocalStorage.ILocalStorageService localStorage
@inject NavigationManager NavigationManager
@inject IModalDialogService ModalDialog

<div class="row mt-4">
    <div class="col-8">
        <h4 class="card-title text-info">Team Players</h4>
    </div>
    <div class="col-3 offset-1">
        <button @onclick="() => HandleAddPlayers(Id.Value)" class="btn btn-primary d-block mr-0 ml-auto">Add Players</button>
    </div>
</div>
<div class="row mt-4">
    <div class="col-12">
        <table class="table table-bordered table-hover">
            <thead>
                <tr>
                    <th>#</th>
                    <th>Name</th>
                    <th>
                        Actions
                    </th>
                </tr>
            </thead>
            <tbody>
                @if (TeamPlayers.Any())
                {
                    int i = 1;
                    @foreach (var teamPlayer in TeamPlayers)
                    {
                        <tr>
                            <td>@i</td>
                            @{i++;}
                            <td>@teamPlayer.Player.Name @teamPlayer.Player.Surname</td>
                            <td>
                                
                                <button class="btn btn-danger" @onclick="() => HandleDelete(teamPlayer.Id)">Delete</button>
                            </td>
                        </tr>
                    }
                }
                else
                {
                    <tr>
                        <td colspan="5">No records found</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>

<DeleteConfirmation IsParentComponentProcessing="IsProcessing" ConfirmationChanged="ConfirmDelete_Click"></DeleteConfirmation>

@code {

    [Parameter]
    public int? Id { get; set; }
    [CascadingParameter]
    public IModalService Modal { get; set; }
    private IEnumerable<TeamPlayerDTO> TeamPlayers { get; set; } = new List<TeamPlayerDTO>();
    private int? DeleteTeamPlayerId { get; set; } = null;
    private bool IsProcessing { get; set; } = false;

    protected async override Task OnInitializedAsync()
    {
        TeamPlayers = await TeamPlayerRepository.GetAllFromTeamSeason(Id.Value);

    }

    private async Task HandleDelete(int teamPlayerId)
    {
        DeleteTeamPlayerId = teamPlayerId;
        await JsRuntime.InvokeVoidAsync("ShowDeleteConfirmationModal");
    }
    public async Task ConfirmDelete_Click(bool isConfirmed)
    {
        IsProcessing = true;
        if (isConfirmed && DeleteTeamPlayerId != null)
        {
            await TeamPlayerRepository.Delete(DeleteTeamPlayerId.Value);
            await JsRuntime.ToastrSuccess("Player removed successfully!");
            TeamPlayers = await TeamPlayerRepository.GetAllFromTeamSeason(Id.Value);
        }
        await JsRuntime.InvokeVoidAsync("HideDeleteConfirmationModal");
        IsProcessing = false;
    }
    async void HandleAddPlayers(int teamSeasonId)
    {
        var parameters = new ModalDialogParameters();
        parameters.Add("TeamSeasonId", Id);
        //Modal.Show<DialogAddPlayer>("Add players", parameters);
        var result = await ModalDialog.ShowDialogAsync<DialogAddPlayer>("Add players", new ModalDialogOptions(), parameters);
    }
}
